
\begin{figure}[t]
\[
\begin{array}[t]{c}
\infrule{AND}\\
\inferS{v^*}{\pure_1}{\pure_2}
{\pstate{2}}{\prestate{2}}{\reldef{2}} \qquad \inferS{v^*}{\pure_1}{\pure_3}
{\pstate{3}}{\prestate{3}}{\reldef{3}}\\
\hline
\inferS{v^*}{\pure_1}{\pure_2{\wedge}\pure_3}
{\pstate{2}{\wedge}\pstate{3}}{\prestate{2}{\wedge}\prestate{3}}{\reldef{2}{\cup}\reldef{3}}
\end{array}
\]
\[
\begin{array}[t]{c}
%
\infrule{UNSAT}\\
\unsat{\atomic{1}} \\
\hline
\inferS{v^*}{\atomic{1}}{\atomic{2}}{\false}{\true}{\emptyset}
\end{array}
\qquad\qquad
\begin{array}[t]{c}
\infrule{VALID}\\
\atomic{1} \Rightarrow~ \atomic{2} \quad %\\
\\
\hline
\inferS{v^*}{\atomic{1}}{\atomic{2}}{\atomic{1}}{\true}{\emptyset}
\end{array}
\]
\[
\begin{array}[t]{c}
\infrule{LHS-CONTRA}\\
{\prestate{}} = \forall (\FV(\atomic{1}){-}v^*) \cdot \neg \atomic{1}\\
\unsat{\atomic{1} {\wedge} \atomic{2}} \quad \prestate{}{\neq}\false\\
\hline
\inferS{v^*}{\atomic{1}}{\atomic{2}}{\false}{\prestate{}}{\emptyset}
\end{array}
\qquad\qquad
\begin{array}[t]{c}
%
\infrule{PRE-DERIVE}\\
\prestate{}{=}\forall (\FV(\atomic{1},\atomic{2}){-}v^*) \cdot (\neg \atomic{1} {\lor} \atomic{2})\\
\prestate{}{\neq}\false \\
\hline
\inferS{v^*}{\atomic{1}}{\atomic{2}}{\atomic{1}{\wedge}\prestate{}}
{\prestate{}}{\emptyset}
\end{array}
\]
\[
\begin{array}[t]{c}
\infrule{REL-DEFN}\\
\inferS{v^*,v_{rel}}{\pure}{v_{rel}(u^*)}
{\true}{\true}{
\{\pure {\to} {v_{rel}(u^*)\}}}
\end{array}
\]
\[
\begin{array}[t]{c}
\infrule{REL-OBLG}\\
\inferS{u^*}{\atomic{1}}{\atomic{2}}{\pstate{1}}{\prestate{1}}{\emptyset}
\qquad \inferS{v^*}{\atomic{1}}{\atomic{2}}
{\pstate{2}}{\prestate{2}}{\emptyset}\\
\hline
\inferS{v^*,v_{rel}}{\atomic{1}{\wedge} {v_{rel}(u^*)}}{\atomic{2}}{\pstate{1}{\wedge}\pstate{2}}
{\prestate{2}}{\{{v_{rel}(u^*)} {\to}{\prestate{1}}\}}
\end{array}
\]
\hide{
\[
\begin{array}[t]{c}
\infrule{REL-OBLIGE}\\
\pure_2=\forall
(\FV(\pure,\atomic{}){-}\{u^*\})\cdot(\neg\pure{\vee}\atomic{}) \qquad \pure_2{\neq}\false\\
\hline
\inferS{v^*,v_{rel}}{\pure{\wedge} {v_{rel}(u^*)}}{\atomic{}}
{\pure{\wedge}\pure_2}{\true}{
%\reldef{}\cup
\{{v_{rel}(u^*)} {\to}{\pure_2}\}}
\end{array}
\]}
\caption{Pure Bi-Abduction Rules}
\label{fig:purerule}
\end{figure}

